/*
 * Copyright (c) 2006-2007 CodeDroids ApS (http://www.codedroids.com)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * For further information about CodeDroids ApS, please see the
 * company website: http://www.codedroids.com
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $LastChangedRevision: 117 $
 * $LastChangedDate: 2007-02-20 11:24:48 +0100 (Tue, 20 Feb 2007) $
 * 
 */

package com.codedroids.oc.templating;

import org.opencms.jsp.*;
import com.codedroids.templating.A_TemplateEngine;


// Just adds an extra config parameter for the appropriate Cms bean - engines using OC are likely to need it.

public abstract class A_OCTemplateEngine extends A_TemplateEngine {

	private CmsJspActionElement cms;
	
	public void setCms(CmsJspActionElement cms) {
		this.cms = cms;
	}
	
	public CmsJspActionElement getCms() {
		return cms;
	}

	/**
	 * Initialises the instance with the given configuration. I.e. do not call it
	 * before the configuration is set.
	 * <p>Default implementation do nothing other than complain if no cms is present
	 * @return
	 */
	public void init() {
		super.init();
		if(cms == null)
			throw new NullPointerException("Cannot initialise when cms is null");
	}

}
