/*
 * Copyright (c) 2006-2007 CodeDroids ApS (http://www.codedroids.com)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * For further information about CodeDroids ApS, please see the
 * company website: http://www.codedroids.com
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $LastChangedRevision: 153 $
 * $LastChangedDate: 2007-03-11 18:43:36 +0100 (Sun, 11 Mar 2007) $
 * 
 */

package com.codedroids.templating;

import net.sf.json.JSONObject;
import java.io.Writer;
import java.lang.NullPointerException;
import java.util.Map;

public abstract class A_TemplateEngine {
	
	private JSONObject configuration;
	
	public void setConfiguration(JSONObject configuration) {
		this.configuration = configuration;
	}
	
	public JSONObject getConfiguration() {
		return configuration;
	}

	/**
	 * Initialises the instance with the given configuration. I.e. do not call it
	 * before the configuration is set.
	 * <p>Default implementation do nothing other than complain if no config is present
	 * @return
	 */
	public void init() {
		if(configuration == null)
			throw new NullPointerException("Cannot initialize when configuration is null");
	}
	
	public abstract void process(Map context, Writer writer) throws TemplatingException;

}
